/*								ShowAllDriveQueueElements.c						*/
/*
 * ShowAllDriveQueueElements.c
 * Copyright  1992-94 Apple Computer Inc. All Rights Reserved.
 *
 * This subroutine scans the linked list of drive queue elements and displays
 * information about each active drive.
 */
#include <stdio.h>
#include <Files.h>
#include <Devices.h>

void					ShowAllDriveQueueElements(void);
void					ShowOneDriveQueueElement(
		register DrvQEl		*drvQElPtr
	);
void					ShowSCSIDeviceIdent(
		short				driverRefNum
	);

void
ShowAllDriveQueueElements(void)
{
		register DrvQEl		*drvQElPtr;
#define DQEL	(*drvQElPtr)

		drvQElPtr = (DrvQEl *) GetDrvQHdr()->qHead;
		while (drvQElPtr != NULL) {
			ShowOneDriveQueueElement(drvQElPtr);
			drvQElPtr = (DrvQEl *) drvQElPtr->qLink;
		}
#undef DQEL
}

void
ShowOneDriveQueueElement(
		register DrvQEl		*drvQElPtr
	)
{
#define DQEL	(*drvQElPtr)

		printf("Drive %2d, driver %3d,", (int) DQEL.dQDrive, (int) DQEL.dQRefNum);
		switch (DQEL.qType) {
		case 0:
			printf(
				"%8lu blocks (small drive)",
				(unsigned long) DQEL.dQDrvSz
			);
			break;
		case 1:
			printf(
				"%8lu blocks (large drive)",
				((unsigned long) DQEL.dQDrvSz)
				+ (((unsigned long) DQEL.dQDrvSz2) * 0x10000L)
			);
			break;
		case 3:
			printf(
				"%8lu blocks (MFS present)",
				((unsigned long) DQEL.dQDrvSz)
			);
			break;
		default:
			printf(
				"%lu %lu blocks (unknown queue type)",
				((unsigned long) DQEL.dQDrvSz),
				((unsigned long) DQEL.dQDrvSz2)
			);
			break;
		}
		ShowSCSIDeviceIdent(DQEL.dQRefNum);
		printf("\n");
#undef DQEL
}

